#****************************************************************************
#**
#**  File     :  /cdimage/units/URB2301/URB2301_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  Cybran Heavy Gun Tower Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local CStructureUnit = import('/lua/cybranunits.lua').CStructureUnit
local MicroFusionLaserGenerator = import('/mods/Supreme w00tlen/hook/lua/cybranheavyturretweapon.lua').MicroFusionLaserGenerator
local utilities = import('/lua/Utilities.lua')
local EffectUtil = import('/lua/EffectUtilities.lua')

XRB2306 = Class(CStructureUnit) {

    Weapons = {
    
        MainGun = Class(MicroFusionLaserGenerator) {
            FxMuzzleFlash = {'/effects/emitters/particle_cannon_muzzle_02_emit.bp',},        
        },
    },
    
	OnStopBeingBuilt = function(self,builder,layer)
        CStructureUnit.OnStopBeingBuilt(self,builder,layer)
       		self:CreateUnitAmbientEffect(layer)
	end,
    
	AmbientExhaustBones = {
		'Exhaust',
    },	
    
    AmbientLandExhaustEffects = {
		'/mods/Supreme w00tlen/hook/effects/emitters/dirty_exhaust_smoke_03_emit.bp',			
	},	
	
	AmbientSeabedExhaustEffects = {
		'/effects/emitters/underwater_vent_bubbles_02_emit.bp',			
	},
	
	CreateUnitAmbientEffect = function(self, layer)
	    if( self.AmbientEffectThread != nil ) then
	    	self.AmbientEffectThread:Destroy()
        end	 
        if self.AmbientExhaustEffectsBag then
        EffectUtil.CleanupEffectBag(self,'AmbientExhaustEffectsBag')
        end        
        
        self.AmbientEffectThread = nil
        self.AmbientExhaustEffectsBag = {} 
	    self.AmbientEffectThread = self:ForkThread(self.UnitLandAmbientEffectThread)          
	end,

	UnitLandAmbientEffectThread = function(self)
		while not self:IsDead() do
            local army = self:GetArmy()			
			
			for kE, vE in self.AmbientLandExhaustEffects do
				for kB, vB in self.AmbientExhaustBones do
					table.insert( self.AmbientExhaustEffectsBag, CreateAttachedEmitter(self, vB, army, vE ))
				end
			end
			
			WaitSeconds(2)
			EffectUtil.CleanupEffectBag(self,'AmbientExhaustEffectsBag')
							
			WaitSeconds(utilities.GetRandomFloat(1,7))
		end		
	end,               
}

TypeClass = XRB2306